﻿Type=Class
Version=5.9
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize As JavaObject
	Return Me
End Sub
' java code to read the obj file and create the lists for meshview
#if java
import java.io.File;
import java.io.FileReader;
import java.io.BufferedReader;
import java.util.List;
import java.util.Map;

public static int doit(String fname,List vertList,List texList,List normsList,List facesList,Map limits) {

		File fn = new File(fname);
		int scanType = 0; // v/n/tx      1 = v/n	
		FileReader input = null;
		try {
			input = new FileReader(fname);
		} catch (Exception e) {
			System.out.println(e);
			System.exit(-1);
		}
		Float xMin=0.0f,yMin=0.0f,zMin=0.0f,xMax=0.0f,yMax=0.0f,zMax=0.0f;
		
		BufferedReader bufRead = new BufferedReader(input);
		
		String myLine = null;

		try {
			while ((myLine = bufRead.readLine()) != null) { 
				String[] parts = myLine.split(" ");
				if (parts[0].equals("v")) {
					Float x = Float.parseFloat(parts[1]);
					Float y = Float.parseFloat(parts[2]);
					Float z = Float.parseFloat(parts[3]);

					xMin = Math.min(xMin,x);
					yMin = Math.min(yMin,y);
					zMin = Math.min(zMin,z);

					xMax = Math.max(xMax,x);
					yMax = Math.max(yMax,y);
					zMax = Math.max(zMax,z);
										
					vertList.add(x);
					vertList.add(y);
					vertList.add(z);
				}
				if (parts[0].equals("vn")) {
					normsList.add(Float.parseFloat(parts[1]));
					normsList.add(Float.parseFloat(parts[2]));
					normsList.add(Float.parseFloat(parts[3]));
				}
				if (parts[0].equals("vt")) {
					texList.add(Float.parseFloat(parts[1]));
					texList.add(1.0f - Float.parseFloat(parts[2]));
				}
				if (parts[0].equals("f")) {
					String f;
					if (parts.length > 5) System.out.println("line len :"+parts.length);
					if (parts.length == 5 && scanType == 0) scanType = 1;
					if (scanType==0){
						f=parts[1]+","+parts[2]+","+parts[3];
					} else {
						f=parts[1]+","+parts[2]+","+parts[3]+","+parts[4];
					}
					f=f.replace("/",",");
					
					String[] is = f.split(",");
					if (scanType == 0){       // 3 triplets
						int v0  = Integer.parseInt(is[0]) - 1;
						int vt0 = Integer.parseInt(is[1]) - 1;
						int n0  = Integer.parseInt(is[2]) - 1;
						int v1  = Integer.parseInt(is[3]) - 1;
						int vt1 = Integer.parseInt(is[4]) - 1;
						int n1  = Integer.parseInt(is[5]) - 1;
						int v2  = Integer.parseInt(is[6]) - 1;
						int vt2 = Integer.parseInt(is[7]) - 1;
						int n2  = Integer.parseInt(is[8]) - 1;
					//file has 	v/vt/vn v/vt/vn v/vt/vn v/vt/vn
					//jfx wants	v/n/tx   - so need to swap around
						facesList.add(v0);
						facesList.add(n0);
						facesList.add(vt0);
						facesList.add(v1);
						facesList.add(n1);
						facesList.add(vt1);
						facesList.add(v2);
						facesList.add(n2);
						facesList.add(vt2);
					}
					if (scanType == 1){   // 4 pairs of coords igmore last pair or u get error
						int v0  = Integer.parseInt(is[0]) - 1;
						int vt0  = Integer.parseInt(is[1]) - 1;
						int v1  = Integer.parseInt(is[2]) - 1;
						int vt1  = Integer.parseInt(is[3]) - 1;
						int v2  = Integer.parseInt(is[4]) - 1;
						int vt2  = Integer.parseInt(is[5]) - 1;
						int v3  = Integer.parseInt(is[6]) - 1;
						int vt3  = Integer.parseInt(is[7]) - 1;
						facesList.add(v0);
						facesList.add(vt0);
						facesList.add(v1);
						facesList.add(vt1);
						facesList.add(v2);
						facesList.add(vt2);
						/*facesList.add(v2);// new here down
						facesList.add(vt2);
						facesList.add(v3);
						facesList.add(vt3);
						facesList.add(v0);
						facesList.add(vt0);*/
					}
				}
				if (parts[0].equals("mtllib")) {  // add material file to limits map
					limits.put("Material",parts[1]);
				}
			} 
		} catch (Exception e) {
			System.out.println(e);
			System.out.println(myLine);
			System.exit(-1);
		}
		limits.put("xMin",xMin);
		limits.put("yMin",yMin);
		limits.put("zMin",zMin);

		limits.put("xMax",xMax);
		limits.put("yMax",yMax);
		limits.put("zMax",zMax);

		return scanType;
}
#End If